(define-module (ui openldap ajax)
    :use-module (alterator woo)
    :use-module (alterator ajax)
    :export (init))


(define (daemon-change)
    (let ((daemon (form-value "daemon")))
    (woo-write "/openldap" 'daemon daemon)))

(define (ui-init)
    (form-update-value "newdnname" ""))

(define (save-main)
    (let ((local (form-value "local"))
          (enable_tls (form-value "enable_tls")))
    (woo "save" "/openldap" 'local local 'enable_tls enable_tls)))


(define (newdn)
    (let ((newdnname (form-value "newdnname")))
      (catch/message
        (lambda()
        (woo "new" "/openldap" 'newdnname newdnname 'language (form-value "language"))
        (form-update-value  "newdnname" "")
        (woo-list "/openldap/avail_dn")))))
        
(define (deldn)
    (let ((selected (form-value "selected"))
          (bdn (form-value "bdn")))
    (woo-delete "/openldap" 'selected selected 'bdn bdn)
    (woo-list "/openldap/avail_dn")))

(define (init)
    (ui-init)
    (form-bind "daemon" "change" daemon-change)
    (form-bind "main_btn" "click" save-main)
    (form-bind "newdn_btn" "click" newdn)
    (form-bind "deldn_btn" "click" deldn))

